dnl
define(PAC_COPY_ORIG_BACK,[
cd include
if test -f mpitestf.h.orig ; then
    cp mpitestf.h.orig mpitestf.h
fi
if test -f foptions.h.orig ; then
    cp foptions.h.orig foptions.h
fi
if test -f mpitest_cfg.h.orig ; then
    cp mpitest_cfg.h.orig mpitest_cfg.h
fi
if test -f mpitest_cfgf.h.orig ; then
    cp mpitest_cfgf.h.orig mpitest_cfgf.h
fi
if test -f mpitest_def.h.orig ; then
    cp mpitest_def.h.orig mpitest_def.h
fi
cd ..
])
dnl
define(PAC_TRY_COMPILE_MPI,[
AC_MSG_CHECKING(if can compile and link a simple MPI program with $MPITEST_CC)
cat > testmpi.c <<EOF
#include "mpi.h"
   
int main(argc, argv) 
int argc;
char **argv;
{
    MPI_Init(&argc, &argv);
    MPI_Finalize();
}
EOF
$MPITEST_CC testmpi.c -o testmpi $MPI_LIB > /dev/null 2>&1
if test ! -s testmpi ; then
    AC_MSG_RESULT(no)
    AC_MSG_ERROR([cannot compile and link a simple MPI program with $MPITEST_CC])
else
    AC_MSG_RESULT(yes)
    /bin/rm testmpi.c testmpi
    if test -f testmpi.o ; then
        /bin/rm testmpi.o
    fi
fi
dnl
dnl
])dnl
dnl
dnl PAC_TEST_FORTTYPES tests to see if the following fortran datatypes are
dnl supported: INTEGER1, INTEGER2, INTEGER4, REAL4, REAL8, DOUBLE_COMPLEX
dnl
define(PAC_TEST_FORTTYPES,dnl
   [
FIX_FILE=0
FORT_INT1=1
FORT_INT2=1
FORT_INT4=1
FORT_REAL4=1
FORT_REAL8=1
FORT_DOUBLE_COMPLEX=1
COUNT=13
AC_MSG_CHECKING(for integer * 1)
cat > testfort.f <<EOF
        subroutine forttype( a )
        integer*1 a
        return
        end
EOF
   $F77 -c testfort.f > /dev/null 2>&1
   if test ! -s testfort.o ; then
       AC_MSG_RESULT(no)
       FORT_INT1=0
       FIX_FILE=1
       COUNT=`expr ${COUNT} - 1`
   else
       AC_MSG_RESULT(yes)
   fi
   /bin/rm -f testfort.f testfort.o
dnl
AC_MSG_CHECKING(for integer * 2)
    cat > testfort.f <<EOF
        subroutine forttype( a )
        integer*2 a
	return
        end
EOF
   $F77 -c testfort.f > /dev/null 2>&1
   if test ! -s testfort.o ; then
       AC_MSG_RESULT(no)
       FORT_INT2=0
       FIX_FILE=1
       COUNT=`expr ${COUNT} - 1`
   else
       AC_MSG_RESULT(yes)
   fi
   /bin/rm -f testfort.f testfort.o
dnl
AC_MSG_CHECKING(for integer * 4)
    cat > testfort.f <<EOF
        subroutine forttype( a )
        integer*4 a
	return
        end
EOF
   $F77 -c testfort.f > /dev/null 2>&1
   if test ! -s testfort.o ; then
       AC_MSG_RESULT(no)
       FORT_INT4=0
       FIX_FILE=1
       COUNT=`expr ${COUNT} - 1`
   else
       AC_MSG_RESULT(yes)
   fi
   /bin/rm -f testfort.f testfort.o
dnl
AC_MSG_CHECKING(for real * 4)
    cat > testfort.f <<EOF
        subroutine forttype( a )
        real*4 a
	return
        end
EOF
   $F77 -c testfort.f > /dev/null 2>&1
   if test ! -s testfort.o ; then
       AC_MSG_RESULT(no)
       FORT_REAL4=0
       FIX_FILE=1
       COUNT=`expr ${COUNT} - 1`
   else
       AC_MSG_RESULT(yes)
   fi
   /bin/rm -f testfort.f testfort.o
dnl
AC_MSG_CHECKING(for real * 8)
    cat > testfort.f <<EOF
        subroutine forttype( a )
        real*8 a
	return
        end
EOF
   $F77 -c testfort.f > /dev/null 2>&1
   if test ! -s testfort.o ; then
       AC_MSG_RESULT(no)
       FORT_REAL8=0
       FIX_FILE=1
       COUNT=`expr ${COUNT} - 1`
   else
       AC_MSG_RESULT(yes)
   fi
   /bin/rm -f testfort.f testfort.o
dnl
AC_MSG_CHECKING(for double complex)
    cat > testfort.f <<EOF
        subroutine forttype( a )
        double complex a
	return
        end
EOF
   $F77 -c testfort.f > /dev/null 2>&1
   if test ! -s testfort.o ; then
       AC_MSG_RESULT(no)
       FORT_DOUBLE_COMPLEX=0
       FIX_FILE=1
       COUNT=`expr ${COUNT} - 1`
   else
       AC_MSG_RESULT(yes)
   fi
   /bin/rm -f testfort.f testfort.o
dnl
   ])dnl
dnl
dnl
dnl PAC_FIX_MPITEST_FILES removes the Fortran Datatype that is not supported
dnl by the current machine.  It creates 2 files, mpitest_cfgf.fix and 
dnl foptions.fix which will have the valid datatypes supported by the 
dnl current machine, and the NUMTOK3 variable will be changed to reflect the
dnl number of supported datatypes.
define(PAC_FIX_MPITEST_FILES,dnl
dnl
   [cd include
    if test ! -s mpitest_cfcf.h.orig ; then
        cp mpitest_cfgf.h mpitest_cfgf.h.orig
    fi
    if test ! -s foptions.h.orig ; then
        cp foptions.h foptions.h.orig
    fi
dnl
    if test "$enable_fortranoptionaltypes" = "no" ; then
        COUNT=7
    fi
    if test $COUNT != 13; then
        sed -e "s/NUMTOK3 = 13/NUMTOK3 = $COUNT/g" mpitest_cfgf.h > temp.fix
        cp temp.fix mpitest_cfgf.h
        /bin/rm temp.fix
    fi        
dnl
    if test "$enable_fortranoptionaltypes" = "no" ; then
        FORT_INT1=0
    fi
    if test $FORT_INT1 = 0; then
	sed -e "s/MPITEST_INTEGER1,//g" mpitest_cfgf.h > temp.fix
        sed -e "s/#define MPITEST_FINTEGER1/C #define MPITEST_FINTEGER1/g" foptions.h > temp2.fix      
        cp temp.fix mpitest_cfgf.h
        cp temp2.fix foptions.h
        /bin/rm temp.fix temp2.fix
    fi
dnl
    if test "$enable_fortranoptionaltypes" = "no" ; then
        FORT_INT2=0
    fi
    if test $FORT_INT2 = 0; then
        sed -e "s/MPITEST_INTEGER2,//g" mpitest_cfgf.h > temp.fix
        sed -e "s/#define MPITEST_FINTEGER2/C #define MPITEST_FINTEGER2/g" foptions.h > temp2.fix      
        cp temp.fix mpitest_cfgf.h
        cp temp2.fix foptions.h
        /bin/rm temp.fix temp2.fix
    fi
dnl
    if test "$enable_fortranoptionaltypes" = "no" ; then
        FORT_INT4=0
    fi
    if test $FORT_INT4 = 0; then
	sed -e "s/MPITEST_INTEGER4,//g" mpitest_cfgf.h > temp.fix
        sed -e "s/#define MPITEST_FINTEGER4/C #define MPITEST_FINTEGER4/g" foptions.h > temp2.fix      
        cp temp.fix mpitest_cfgf.h
        cp temp2.fix foptions.h
        /bin/rm temp.fix temp2.fix
    fi
dnl
    if test "$enable_fortranoptionaltypes" = "no" ; then
        FORT_REAL4=0
    fi
    if test $FORT_REAL4 = 0; then
	sed -e "s/MPITEST_REAL4,//g" mpitest_cfgf.h > temp.fix
        sed -e "s/#define MPITEST_FREAL4/C #define MPITEST_FREAL4/g" foptions.h > temp2.fix      
        cp temp.fix mpitest_cfgf.h
        cp temp2.fix foptions.h
        /bin/rm temp.fix temp2.fix
    fi
dnl
    if test "$enable_fortranoptionaltypes" = "no" ; then
        FORT_REAL8=0
    fi
    if test $FORT_REAL8 = 0; then
	sed -e "s/MPITEST_REAL8,//g" mpitest_cfgf.h > temp.fix 
        sed -e "s/#define MPITEST_FREAL8/C #define MPITEST_FREAL8/g" foptions.h > temp2.fix      
        cp temp.fix mpitest_cfgf.h        
        cp temp2.fix foptions.h
        /bin/rm temp.fix temp2.fix
    fi
dnl
    if test "$enable_fortranoptionaltypes" = "no" ; then
        FORT_DOUBLE_COMPLEX=0
    fi
    if test $FORT_DOUBLE_COMPLEX = 0; then
	sed -e "s/MPITEST_DOUBLE_COMPLEX,//g" mpitest_cfgf.h > temp.fix
        sed -e "s/#define MPITEST_FDOUBLE_COMPLEX/C #define MPITEST_FDOUBLE_COMPLEX/g" foptions.h > temp2.fix      
        cp temp.fix mpitest_cfgf.h
        cp temp2.fix foptions.h
        /bin/rm temp.fix temp2.fix
    fi
dnl
	sed -e "/^[ ]*\&[ ]*$/d" mpitest_cfgf.h > temp.fix
	cp temp.fix mpitest_cfgf.h
	/bin/rm temp.fix
dnl
    cd ../
dnl
   ])dnl
dnl
dnl
dnl PAC_FIX_DEF changes '#define MPITEST_long_double_def' to 0 in mpitest_def.h
dnl This routine is called when the MPI_LONG_DOUBLE is incompatible with
dnl the current compiler's long double 
define(PAC_FIX_DEF,dnl
    [cd include
     if test ! -s mpitest_def.h.orig ; then
         cp mpitest_def.h mpitest_def.h.orig
     fi
     sed -e "s/#define MPITEST_long_double_def 1/#define MPITEST_long_double_def 0/g" mpitest_def.h > temp.fix
     cp temp.fix mpitest_def.h
     /bin/rm temp.fix
     cd ../
dnl
    ])dnl
dnl
dnl
dnl PAC_FIX_CFG(datatype) removes the datattype ($1) from mpitest_cfg.h
dnl This routine is called when the MPI_datatype is incompatible with the 
dnl current compiler's datatype, or if fortran-optional-datatypes is disabled.
define(PAC_FIX_CFG,dnl
    [cd include
     if test ! -s mpitest_cfg.h.orig ; then
         cp mpitest_cfg.h mpitest_cfg.h.orig
     fi
     sed -e "s/$1,//g" mpitest_cfg.h > temp.fix
     cp temp.fix mpitest_cfg.h
     /bin/rm temp.fix
     cd ../
dnl
   ])dnl
dnl
dnl
dnl PAC_TEST_DATATYPES first creates a C program called 'testtypes' which 
dnl checks to see if all the MPI_Datatypes are compatible with the current
dnl compiler's corresponding datatype.  It then compiles and executes this
dnl program.  If there are any incompatible datatypes, then 'testtypes' will
dnl write them out to an output file.  Any datatypes in this output file will
dnl be subsequently removed from mpitest_cfg.h and if it is a long double,
dnl then mpitest_def.h will also be affected,
define(PAC_TEST_DATATYPES,dnl
    [cat > testtypes.c <<EOF
#include "mpi.h"
#include <stdio.h>

int main(argc, argv)
	int argc;
         char **argv;
     {
         int m_size, c_size,i;
         MPI_Aint i_extent;
         char sysstr[50];

         FILE *f=fopen("test.out","w");
         if (!f) exit(1); 
         MPI_Init(&argc, &argv);

         MPI_Type_size(MPI_INT, &m_size);
         c_size = sizeof(int);
         if (m_size != c_size)  
             fprintf( f, "%s\n", "FIX_INT");        

         MPI_Type_size(MPI_SHORT, &m_size);
         c_size = sizeof(short);
         if (m_size != c_size)  
             fprintf( f, "%s\n", "FIX_SHORT");        

         MPI_Type_size(MPI_LONG, &m_size);
         c_size = sizeof(long);
         if (m_size != c_size)  
             fprintf( f, "%s\n", "FIX_LONGS");

         MPI_Type_size(MPI_UNSIGNED_SHORT, &m_size);
         c_size = sizeof(unsigned short);
         if (m_size != c_size)  
             fprintf( f, "%s\n", "FIX_UN_SHORT");

         MPI_Type_size(MPI_UNSIGNED, &m_size);
         c_size = sizeof(unsigned int);
         if (m_size != c_size)  
             fprintf( f, "%s\n", "FIX_UN_INT");

         MPI_Type_size(MPI_UNSIGNED_LONG, &m_size);
         c_size = sizeof(unsigned long);
         if (m_size != c_size)  
             fprintf( f, "%s\n", "FIX_UN_LONG");

         MPI_Type_size(MPI_FLOAT, &m_size);
         c_size = sizeof(float);
         if (m_size != c_size)  
             fprintf( f, "%s\n", "FIX_FLOAT");

         MPI_Type_size(MPI_DOUBLE, &m_size);
         c_size = sizeof(double);
         if (m_size != c_size)  
             fprintf( f, "%s\n", "FIX_DOUBLE");

         MPI_Type_size(MPI_CHAR, &m_size);
         c_size = sizeof(signed char);
         if (m_size != c_size)  
             fprintf( f, "%s\n", "FIX_CHAR");

         MPI_Type_size(MPI_UNSIGNED_CHAR, &m_size);
         c_size = sizeof(unsigned char);
         if (m_size != c_size)  
             fprintf( f, "%s\n", "FIX_UN_CHAR");

         MPI_Type_size(MPI_LONG_DOUBLE, &m_size);
         c_size = sizeof(long double);
         if (m_size != c_size)  
             fprintf( f, "%s\n", "FIX_LONG_DOUBLE");

         MPI_Finalize(); 
      }
EOF
 
dnl
       $MPITEST_CC testtypes.c -o testtypes $MPI_LIB   

dnl
      if test ! -x testtypes ; then
        print_error "Unable to compile (or execute) C program"
	print_error "(in order to test for incompatible data types)"
      else
          $MPIRUN -np 1 testtypes
      fi
dnl
      if test -f test.out ; then
	if test -s test.out ; then
          FIX_CFG=1
          AC_MSG_CHECKING(if MPI_INT is compatible with current compiler's integer)
          cat test.out | grep FIX_INT > temp
	  if test -s temp ; then
            AC_MSG_RESULT(no)
	    PAC_FIX_CFG(MPITEST_int)          
          else
	    AC_MSG_RESULT(yes)
          fi
	  /bin/rm temp
dnl
          AC_MSG_CHECKING(if MPI_SHORT is compatible with current compiler's short)
	  cat test.out | grep FIX_SHORT > temp
	  if test -s temp ; then
            AC_MSG_RESULT(no)
	    PAC_FIX_CFG(MPITEST_short_int)          
          else
            AC_MSG_RESULT(yes)            
          fi
          /bin/rm temp
dnl
          AC_MSG_CHECKING(if MPI_LONG is compatible with current compiler's long integer)
          cat test.out | grep FIX_LONGS > temp
	  if test -s temp ; then
            AC_MSG_RESULT(no)
	    PAC_FIX_CFG(MPITEST_long)	  
          else
	    AC_MSG_RESULT(yes)
	  fi
	  /bin/rm temp
dnl
          AC_MSG_CHECKING(if MPI_UNSIGNED_SHORT is compatible with current compiler's unsigned short integer)
          cat test.out | grep FIX_UN_SHORT > temp
	  if test -s temp ; then
            AC_MSG_RESULT(no)
	    PAC_FIX_CFG(MPITEST_unsigned_short)	  
          else
            AC_MSG_RESULT(yes)
          fi
	  /bin/rm temp
dnl
          AC_MSG_CHECKING(if MPI_UNSIGNED_INTEGER is compatible with current compiler's unsigned integer)
	  cat test.out | grep FIX_UN_INT > temp
	  if test -s temp ; then
            AC_MSG_RESULT(no)
	    PAC_FIX_CFG(MPITEST_unsigned)	  
          else
            AC_MSG_RESULT(yes)
          fi
	  /bin/rm temp
dnl
          AC_MSG_CHECKING(if MPI_UNSIGNED_LONG is compatible with current compiler's unsigned long integer)
          cat test.out | grep FIX_UN_LONG > temp
          if test -s temp ; then
            AC_MSG_RESULT(no)
	    PAC_FIX_CFG(MPITEST_unsigned_long)	  
          else
            AC_MSG_RESULT(yes)
          fi
	  /bin/rm temp
dnl
          AC_MSG_CHECKING(if MPI_FLOAT is compatible with current compiler's float)
	  cat test.out | grep FIX_FLOAT > temp
          if test -s temp ; then
            AC_MSG_RESULT(no)
	    PAC_FIX_CFG(MPITEST_float)	  
	  else
            AC_MSG_RESULT(yes)
          fi
	  /bin/rm temp
dnl  
          AC_MSG_CHECKING(if MPI_DOUBLE is compatible with current compiler's double)
          cat test.out | grep FIX_DOUBLE > temp
          if test -s temp ; then
            AC_MSG_RESULT(no)
	    PAC_FIX_CFG(MPITEST_double)	  
	  else
            AC_MSG_RESULT(yes)
          fi
	  /bin/rm temp
dnl
          AC_MSG_CHECKING(if MPI_CHAR is compatible with current compiler's char)
          cat test.out | grep FIX_CHAR > temp
          if test -s temp ; then
            AC_MSG_RESULT(no)
	    PAC_FIX_CFG(MPITEST_char)
	  else
            AC_MSG_RESULT(yes)	  
          fi
	  /bin/rm temp
dnl
          AC_MSG_CHECKING(if MPI_UNSIGNED_CHAR is compatible with current compiler's unsigned char)
          cat test.out | grep FIX_UN_CHAR > temp
          if test -s temp ; then
            AC_MSG_RESULT(no)
	    PAC_FIX_CFG(MPITEST_unsigned_char)	  
	  else
            AC_MSG_RESULT(yes)
          fi
	  /bin/rm temp
dnl
          AC_MSG_CHECKING(if MPI_LONG_DOUBLE is compatible with current compiler's long double)
          cat test.out | grep FIX_LONG_DOUBLE > temp
          if test -s temp ; then
            AC_MSG_RESULT(no)
	    PAC_FIX_CFG(MPITEST_long_double)
            FIX_DEF=1
            PAC_FIX_DEF
	  else
            AC_MSG_RESULT(yes)
          fi
	  /bin/rm temp
dnl
        fi
      fi
      if test -f testtypes.c ; then
          /bin/rm testtypes.c
       fi
       if test -f testtypes.o ; then
	  /bin/rm testtypes.o
       fi
       if test -f testtypes ; then
           /bin/rm testtypes
       fi
       if test -f test.out ; then
           /bin/rm test.out
        fi
   ])dnl
dnl
dnl
dnl
dnl PAC_INFO_ERROR generates a PERL script, which when executed, runs on all
dnl fortran tests to ensure that ERRORSTRING is not written out any longer
dnl than size (the size allocated by MPI_ERROR_STRING.
define(PAC_INFO_ERROR,dnl
[
if test -z "$PERL" ; then
    AC_PATH_PROG(PERL,perl)
fi
changequote(`,')dnl
    cat > info_error.pl <<EOF
#! $PERL
    \$fortrandir = \$ARGV[0];

    $|=1;
    opendir(FORTRAN, \$fortrandir) ||
        die("Unable to open directory\n");
    @fortrandir = grep(!/^\./, readdir(FORTRAN));

    foreach \$testdir (@fortrandir) {
        \$test_workdir = \$ARGV[0] . "/" . \$testdir;
        opendir(TEST_WORKDIR, \$test_workdir) ||
            die("Unable to open directory\n");
        print ".";  
  
        @err_func_dirs = grep(!/^\./, readdir(TEST_WORKDIR));
        foreach \$error_func (@err_func_dirs) {
	    \$error_func_dir = \$test_workdir . "/" . \$error_func;
            opendir(DIR, \$error_func_dir) ||
	        die("Unable to open directory\n");
            print ".";  

            @filelist = grep(!/^\./, grep(/^MPI/, readdir(DIR)));

            \$cntline = 5;
            foreach \$file (@filelist) {   # begin foreach \$file
            \$newdir = \$error_func_dir . "/" . \$file . "/";
            opendir(WORKDIR, "\$newdir") ||
	        die("Unable to open \$file directory\n");
            chdir(\$newdir);
	    \$cntline--; if (\$cntline == 0) { print "."; \$cntline = 5; }

            @node_file = grep (/node.F/, readdir(WORKDIR));
            \$length_node = @node_file;
            if (\$length_node == 1) {   # begin if \$length_node
	        (\$node_file) = @node_file;
	        unless (open(OLDNODE, "\$node_file") ) {
	            print ("Cannot open \$node_file\n");
	        }

	        unless (open(NEWNODE, ">temp.f") ) {
	            print ("Cannot open temp.f\n");
	        }

	        while (\$node_line = <OLDNODE>) {   # begin while \$node_line
	            \$flag = 0;
                    \$result_error = \$node_line =~ /CALL MPI_ERROR_STRING/;
	            print NEWNODE (\$node_line);
                    if (\$result_error) {   # begin if \$result_error
	                \$position = `index'(\$node_line, "CALL");
                        \$sub_node = `substr'(\$node_line, \$position);
		        chop(\$sub_node);
		        @node_error = split(/,/, \$sub_node);
		        \$length = @node_error;
		        if (\$length < 3) {   # begin if \$length
		            \$node_line = <OLDNODE>;
		            \$result_size = \$node_line =~ /SIZE/;
		            if (\$result_size) {
			        \$flag = 1;
		            }
		            print NEWNODE (\$node_line);
		        }  # end if \$length
                        elsif ( (\$node_error[2] eq "SIZE") || (\$node_error[2] eq " SIZE") ) {   # begin double if
		            \$flag = 1;
		        }  # end double if
		        if (\$flag) {  # begin if \$flag
		            \$node_line = <OLDNODE>;
                            \$result_dollar = \$node_line =~ /\\$/;
		            if  (\$result_dollar) {   # begin if \$result_dollar
			        print NEWNODE (\$node_line);
			        \$node_line = <OLDNODE>;
		            }   # end if \$result_dollar
                            \$result_blank = \$node_line !~ /[A-Z]/;
		            if (\$result_blank) {   # begin if \$result_blank
			        print NEWNODE (\$node_line);
			        \$node_line = <OLDNODE>;
		            }   # end if \$result_blank
		            \$result_info = \$node_line =~ /WRITE\(INFOBUF,/;
                            if (\$result_info) {   # begin if \$result_info
		                \$position = `index'(\$node_line, "WRITE");
		                \$sub_node = `substr'(\$node_line, \$position);
		                chop(\$sub_node);
			        chop(\$node_line);
		                @node_write = split(/ /, \$sub_node);
		                if ( (\$node_write[2] eq "ERRORSTRING") || (\$node_write[1] eq "ERRORSTRING") )  {   # begin if \$node_write[2]    
			            \$newline = \$node_line . "(1:SIZE)\n";
			            print NEWNODE (\$newline);
		                }   # end if \$node_write[2]
			        else {   # begin else
			            print NEWNODE ("\$node_line\n");
			        }   # end else
                             }   # end if \$result_info
		             else {   # begin else
			         print NEWNODE ("\$node_line\n");
	                     }   # end else
		        }   # end if flag
	            }   # end if \$result_error
	        }   #end while \$node_line
                \$mv_str = "mv temp.f node.F";
                system(\$mv_str);
              }   #end if \$length_node
            }   # foreach \$file
        }  # foreach err_func
     }  #foreach \$testdir
EOF
changequote([,])dnl
    ])dnl
dnl
dnl
dnl PAC_KSH_SH generates a PERL script, which when executed, ensures that the
dnl first line of each .sh file in each test directory will begin with
dnl #!/bin/sh
define([PAC_KSH_SH],dnl
[
if test -z "$PERL" ; then
    AC_PATH_PROG(PERL,perl)
fi
changequote(,)dnl
    cat > ksh_sh.pl <<EOF
#! $PERL
    \$fortrandir = \$ARGV[0];
    $|=1;
    opendir(FORTRAN, \$fortrandir) ||
        die("Unable to open directory\n");
    @fortrandir = grep(!/^\./, readdir(FORTRAN));

    foreach \$testdir (@fortrandir) {
        \$test_workdir = \$ARGV[0] . "/" . \$testdir;
        opendir(TEST_WORKDIR, \$test_workdir) ||
            die("Unable to open directory\n");
        print ".";

        @err_func_dirs = grep(!/^\./, readdir(TEST_WORKDIR));
        foreach \$error_func (@err_func_dirs) {
	    \$error_func_dir = \$test_workdir . "/" . \$error_func;
            opendir(DIR, \$error_func_dir) ||
	        die("Unable to open directory\n");
            print ".";

            @filelist = grep(!/^\./, grep(/^MPI/, readdir(DIR)));

            \$cntline = 5;
            foreach \$file (@filelist) {   # begin foreach \$file
            \$newdir = \$error_func_dir . "/" . \$file . "/";
            opendir(WORKDIR, "\$newdir") ||
	        die("Unable to open \$file directory\n");
            chdir(\$newdir);
	    \$cntline--; if (\$cntline == 0) { print "."; \$cntline = 5; }

            @sh_file = grep (/sh\$/, readdir(WORKDIR));
            \$length_sh = @sh_file;
            if (\$length_sh == 1) {
	        (\$sh_file) = @sh_file;
	        unless (open(SH, "+<\$sh_file") ) {
	            print ("Cannot open \$sh_file\n");
	        }
	        \$sh_line = <SH>;
	        \$sh_line = "";
	        seek(SH,0,0);
	        print SH ("\$sh_line\n");
	        \$new_line = "#! /bin/sh";
	        seek(SH,0,0);
	        print SH ("\$new_line\n");
            } #end if \$length sh == 1
          } #end foreach \$file
        } #end foreach \$error_func
    } #end foreach \$testdir
EOF
changequote([,])dnl
dnl    which perl > PERL
dnl    cat > temp<<eof
dnl #! 
dnl eof
dnl    paste -d"\0" temp PERL > temp1
dnl    cat temp1 ksh_sh.pl > temp2
dnl    cp temp2 ksh_sh.pl
dnl    /bin/rm -f temp temp1 temp2 PERL 
    ])dnl
dnl
dnl   
dnl
define(PAC_FIX_START_FILE,dnl
[changequote(!,!)dnl
    cd bin
dnl
    PWD=pwd
    Q=\`
    cat > startjob.${MPITEST_ARCH} <<EOF
    #!/bin/sh

    if test -z "\$!2!"
    then
       echo "ERROR: \$!0! \"-appname\" option: argument required"
       exit 201
    else
       if test -x "\$!2!"
       then
           # run test 
           dir=$Q$PWD$Q
           cd \$dir
           \${MPIRUN} -np \$MPITEST_NPROCS \$!2!
       else
          echo "ERROR: \$!0! \"-appname\" option: \$!2! does not exist or is not executable"
          exit 201
       fi
    fi
EOF
changequote([,])
dnl
if test ! -x "startjob.${MPITEST_ARCH}" ; then
    chmod +x startjob.${MPITEST_ARCH}
fi
dnl
cd ../
dnl
    ])dnl
dnl
